/*
*	  Copyright  2004 Rosiello Security
*
*    	       http://www.rosiello.org
*
**********************************************************************
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 1, or (at your option)
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
***********************************************************************
*
* AUTHOR : Angelo Rosiello
* CONTACT: angelo@rosiello.org
*
*/


#include "library.h"

#define TIMEOUT 8
#define IP_LOG "ip.log"
#define PROXY_OK_LOG "proxy_ok.log"


void inizializzo( )	;
void timeout( )		;
void logging( )		;

char buffer;

int check_proxy( char *port )
{
	int connetti, i, fd, eof, finished, porta, sd, k;
	char connected[]="HTTP/1.0 200"; 					//standard RFC
	char errore[]="HTTP/1.0 403"; 						//standard RFC
	char conn[]="CONNECT";
	char memoria[1024], server[1024], temp[1024];
	char ch;
	struct sockaddr_in server_addr;
	struct timeval tempo;

    signal( SIGALRM, timeout )	; 						//closing the connection after 8 seconds
	alarm( TIMEOUT )			;
	signal( SIGPIPE, SIG_IGN )	;

	eof=1; finished = 0;
	for(i=0; i<1024; i++) memoria[i]='\0';
	for(i=0; i<1024; i++) server[i]='\0';
	i=0;
	porta = atoi(port);

	fd = open( IP_LOG, O_RDONLY );
	if( fd < 0 )
	{
		perror( "Error Opening File" );
		return ( -1 );
	}
	while ( eof )
	{
		for(i=0; i<1024; i++) memoria[i]='\0';
		for(i=0; i<1024; i++) server[i]='\0';
		i=0;
		finished = 0;
		while( !finished )
		{
			eof = read( fd, &ch, 1 );
			if( ch=='\n' || eof==0 ) finished = 1;
			else
			{
				memoria[i]=ch;
				i++;
			}
		}

		if(memoria[0]=='\0' || memoria[0]=='\n') return( -1 );
		for(k=0; k<i; k++) server[k]=memoria[k];

//		printf("ADDRESS = %s\n", server);

		inizializzo( &server_addr, porta, (long) inet_addr(memoria) ); 	//address initialization

		sprintf( temp, "%s %s:%d HTTP/1.0\n\n",conn,memoria,porta );
    	for( i=0; i<1024; i++ ) memoria[i]='\0'; 						//cleaning
		i = 0;

		sd = socket( AF_INET, SOCK_STREAM, 0 ); 						//make the socket
		if( sd < 0 )
		{
			perror( "Socket" );
			return ( -1 );
		}
//		assert(sd >=0);

		connetti = connect( sd, (struct sockaddr *) &server_addr, sizeof(server_addr) );
		if(connetti != 0)
		{
			perror( "Connection" );
		}

		else
		{
			write( sd,temp,strlen(temp) );
			do
			{
				read(sd,&buffer,1);
				memoria[i]=buffer;
				i++;
			} while( buffer != '\n' && buffer != '\0' );
			if( strncasecmp(memoria,connected,12)==0 )
			{
		//		fprintf(stdout, "\t\tSock: working\n");
				logging( server, porta );
			}
		}
		close( sd ); //close the socket

	}
	close( fd );
	return( 0 );
}

//REQUIRES: arguments != NULL
//EFFECTS : initializing address
void inizializzo( struct sockaddr_in *address, int port, long IP )
{
	address -> sin_family = AF_INET;
	address -> sin_port = htons((u_short)port);
    address -> sin_addr.s_addr = IP;
}

//REQUIRES: true
//EFFECTS : it establishes timeout
void timeout()
{
		printf( "\t\tConnection Timed Out!\n" );
		buffer = '\0';
}

//REQUIRES: (ip && porta) != NULL
//EFFECTS : logging valid proxy
void logging(char *ip, int porta)
{
		int  fd;
		char mask[32];

		fd = open( PROXY_OK_LOG, O_CREAT | O_WRONLY | O_APPEND, 0644 );
		if ( fd < 0 )
		{
			perror( "File" );
			exit( -1 );
		}
		sprintf( mask, "%s:%d", ip, porta );
		write( fd, mask, strlen(mask) );
		close( fd );
}
